include:
  - project: 'repos/releng/kokkuri'
    file: 'includes/images.yaml'

stages:
  - build
  - publish

build-postgresql:
  extends: .kokkuri:build-image
  stage: build
  variables:
    BUILD_VARIANT: postgresql
    BUILD_CONFIG: ./blubber-postgresql.yaml
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS'
      when: never
    - if: $CI_COMMIT_BRANCH != 'main'
  interruptible: true

publish:postgresql:
  extends: .kokkuri:build-and-publish-image
  stage: publish
  variables:
    BUILD_VARIANT: postgresql
    BUILD_CONFIG: ./blubber-postgresql.yaml
    PUBLISH_IMAGE_NAME: 'repos/data-engineering/postgresql-kubernetes/postgresql'
    PUBLISH_IMAGE_TAG: '${KOKKURI_PIPELINE_TIMESTAMP}-${CI_COMMIT_SHA}'
  tags:
    - trusted
  rules:
    - if: $CI_COMMIT_BRANCH == "main" && $CI_COMMIT_REF_PROTECTED
  interruptible: true

build-cloudnative-pg:
  extends: .kokkuri:build-image
  stage: build
  variables:
    BUILD_VARIANT: operator
    BUILD_CONFIG: ./blubber-operator.yaml
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS'
      when: never
    - if: $CI_COMMIT_BRANCH != 'main'
  interruptible: true

publish:cloudnative-pg:
  extends: .kokkuri:build-and-publish-image
  stage: publish
  variables:
    BUILD_VARIANT: operator
    BUILD_CONFIG: ./blubber-operator.yaml
    PUBLISH_IMAGE_EXTRA_TAGS: '${KOKKURI_PIPELINE_TIMESTAMP}'
    PUBLISH_IMAGE_NAME: 'repos/data-engineering/postgresql-kubernetes/cloudnative-pg'
    PUBLISH_IMAGE_TAG: '${KOKKURI_PIPELINE_TIMESTAMP}-${CI_COMMIT_SHA}'
  tags:
    - trusted
  rules:
    - if: $CI_COMMIT_BRANCH == "main" && $CI_COMMIT_REF_PROTECTED
  interruptible: true
